var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewEncapsulation, Input, NgModule, ContentChildren, QueryList } from '@angular/core';
import { CommonModule } from "@angular/common";
import { AccordionItem } from './AccordionItem';
import { Collapse } from '../../animations/Collapse/Collapse';
export let Accordion = class Accordion {
    constructor() {
        this.closeOthers = true;
        this.duration = 250;
        this.itemEvents = [];
    }
    ngAfterContentInit() {
        this.items.changes.subscribe(i => this.registerItems());
        this.registerItems();
    }
    registerItems() {
        for (let event of this.itemEvents)
            event.unsubscribe();
        for (let item of this.items.toArray()) {
            item.openChange.subscribe(() => {
                this.closeOtherItems(item);
            });
        }
    }
    closeOtherItems(openItem) {
        if (!this.closeOthers)
            return;
        this.items.forEach((item) => {
            if (item !== openItem) {
                item.open = false;
            }
        });
    }
};
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Accordion.prototype, "closeOthers", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Number)
], Accordion.prototype, "duration", void 0);
__decorate([
    ContentChildren(AccordionItem), 
    __metadata('design:type', QueryList)
], Accordion.prototype, "items", void 0);
Accordion = __decorate([
    Component({
        selector: 'accordion',
        template: `<ng-content></ng-content>`,
        styles: ["\n      .fuel-ui-accordion {\n        background-color: #fff;\n        border: 1px solid #ddd;\n        border-radius: 4px; }\n        .fuel-ui-accordion .fuel-ui-clickable {\n          cursor: pointer; }\n          .fuel-ui-accordion .fuel-ui-clickable.disabled {\n            cursor: not-allowed; }\n        .fuel-ui-accordion .fuel-ui-accordion-heading {\n          background-color: #f5f5f5;\n          border-bottom: 1px solid #ddd;\n          border-top-left-radius: 3px;\n          border-top-right-radius: 3px;\n          color: #333;\n          padding: 10px 15px; }\n          .fuel-ui-accordion .fuel-ui-accordion-heading.text-muted {\n            color: #818a91 !important; }\n        .fuel-ui-accordion .fuel-ui-accordion-body {\n          padding: 15px; }\n    "],
        encapsulation: ViewEncapsulation.None,
        animations: [Collapse(350)]
    }), 
    __metadata('design:paramtypes', [])
], Accordion);
const accordionComponents = [
    Accordion,
    AccordionItem
];
export let FuiAccordionModule = class FuiAccordionModule {
};
FuiAccordionModule = __decorate([
    NgModule({
        imports: [CommonModule],
        declarations: accordionComponents,
        exports: accordionComponents
    }), 
    __metadata('design:paramtypes', [])
], FuiAccordionModule);
