var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
import { Attribute, AttributeColumns, AttributesDefaultSort } from '../../utilities/demoUtilities';
export let DatePickerDemo = class DatePickerDemo {
    constructor() {
        this.datePickerValue = new Date(2016, 7, 6);
        this.datePickerFieldValue = "8/6/2016";
        this.attributes = [
            new Attribute('minDate', 'string|Date', 'new Date(1900,0,1)', 'Minimum selectable date'),
            new Attribute('maxDate', 'string|Date', 'new Date(2200,0,1)', 'Maximum selectable date'),
            new Attribute('dateFilter', 'function(date): boolean', 'null', 'Filter to disable dates. A return of <i>false</i> will disable the day'),
            new Attribute('value', 'Date', 'null', 'Two-way binding of the selected DateRange')
        ];
        this.dateFieldAttributes = [
            new Attribute('date', 'Date', 'null', 'Two-way binding of the selected date'),
            new Attribute('value', 'string|Date', 'null', 'Two-way binding of the selected date'),
            new Attribute('ngModel', 'string', 'null', 'Two-way binding of the result input string'),
        ];
        this.attributesColumns = AttributeColumns;
        this.attributesSort = AttributesDefaultSort;
    }
    dateFilter(d) {
        if ([2].indexOf(d.getDay()) > -1)
            return false;
        return true;
    }
};
DatePickerDemo = __decorate([
    Component({
        template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">DatePicker</h2><p class=\"card-text\">DatePicker is a custom component to select a single date on a calendar</p></div></div></div><div class=\"row\"><div class=\"col-md-4\"><div class=\"form-group\"><label for=\"date\">Pick a Date</label><date-picker minDate=\"11/1/2015\" maxDate=\"11/12/2016\" [dateFilter]=\"dateFilter\" [(value)]=\"datePickerValue\"><div class=\"date-picker-input-group\"><input name=\"date\" [(ngModel)]=\"datePickerFieldValue\" dateField class=\"form-control\" placeholder=\"pick a date\"></div></date-picker></div></div><div class=\"col-md-4\">date-picker value: {{datePickerValue}}<br>input ngModel: {{datePickerFieldValue}}</div></div><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}DATE_PICKER_PROVIDERS{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre><h3>Getting Started</h3><p>DatePicker is a custom element to select a date on a calendar. It supports filtering of dates so that you can disable dates programmatically. Also supports min and max dates</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;div class=&quot;form-group&quot;&gt;\n        &lt;label for=&quot;date&quot;&gt;Pick a Date&lt;/label&gt;\n        &lt;date-picker\n            minDate=&quot;11/1/2015&quot;\n            maxDate=&quot;11/12/2016&quot; \n            [dateFilter]=&quot;dateFilter&quot;\n            (valueChange)=&quot;datePickerValue&quot;&gt;\n            &lt;div class=&quot;date-picker-input-group&quot;&gt;\n                &lt;input name=&quot;date&quot; dateField class=&quot;form-control&quot; value=&quot;5/6/2016&quot; placeholder=&quot;pick a date&quot; /&gt;\n            &lt;/div&gt;\n        &lt;/date-picker&gt;\n    &lt;/div&gt;\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class DatePickerExample {{'{'}}\n        datePickerValue: Date;\n    \n        dateFilter(d: Date): boolean {{'{'}}\n        \n            //every Tuesday\n            if([2].indexOf(d.getDay()) > -1)\n                return false;\n        \n            return true;\n        {{'}'}}\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"attributes\" [sort]=\"attributesSort\">Loading table...</table-sortable><h3>DateField Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"dateFieldAttributes\" [sort]=\"attributesSort\">Loading table...</table-sortable></div>\n  "
    }), 
    __metadata('design:paramtypes', [])
], DatePickerDemo);
