var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
import { DateRange } from '../../utilities/utilities';
import { Attribute, AttributeColumns, AttributesDefaultSort } from '../../utilities/demoUtilities';
export let DateRangePickerDemo = class DateRangePickerDemo {
    constructor() {
        this.arrivalDate = new Date(2017, 7, 6);
        this.departureDate = new Date(2017, 7, 10);
        this.dateRangePickerValue = new DateRange(this.arrivalDate, this.departureDate);
        this.attributes = [
            new Attribute('minDate', 'string|Date', 'new Date(1900,0,1)', 'Minimum selectable date'),
            new Attribute('maxDate', 'string|Date', 'new Date(2200,0,1)', 'Maximum selectable date'),
            new Attribute('dateFilter', 'function(date): boolean', 'null', 'Filter to disable dates. A return of <i>false</i> will disable the day'),
            new Attribute('value', 'DateRange', 'null', 'Two-way binding of the selected DateRange')
        ];
        this.dateFieldAttributes = [
            new Attribute('date', 'Date', 'null', 'Two-way binding of the selected date'),
            new Attribute('value', 'string|Date', 'null', 'Two-way binding of the selected date'),
            new Attribute('ngModel', 'string', 'null', 'Two-way binding of the result input string'),
        ];
        this.attributesColumns = AttributeColumns;
        this.attributesSort = AttributesDefaultSort;
    }
    //arrivalDate = "8/6/2016";
    //departureDate = "8/10/2016";
    datePickerValueChange(event) {
        this.dateRangePickerValue = event;
    }
    dateFilter(d) {
        if ([2].indexOf(d.getDay()) > -1)
            return false;
        return true;
    }
};
DateRangePickerDemo = __decorate([
    Component({
        template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">DateRangePicker</h2><p class=\"card-text\">DateRangePicker is a custom component to select a date range on a single calendar</p></div></div></div><section class=\"row\"><div class=\"col-md-4\"><div class=\"form-inline\"><date-range-picker minDate=\"11/1/2014\" maxDate=\"11/12/2017\" [dateFilter]=\"dateFilter\" (valueChange)=\"datePickerValueChange($event)\"><div class=\"form-group\"><label for=\"arrival\">Arrival Date</label><div class=\"date-picker-input-group\"><input name=\"arrival\" [(date)]=\"arrivalDate\" startDateField class=\"form-control\" placeholder=\"Arrival\"></div></div><div class=\"form-group\"><label for=\"departure\">Departure Date</label><div class=\"date-picker-input-group\"><input name=\"departure\" [(date)]=\"departureDate\" endDateField class=\"form-control\" placeholder=\"Departure\"></div></div></date-range-picker></div></div><div class=\"col-md-6\">value.start: {{dateRangePickerValue.start}}<br>value.end: {{dateRangePickerValue.end}}<br>startDateField: {{arrivalDate}}<br>endDateField: {{departureDate}}<br></div></section><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}DateRange, DATE_PICKER_PROVIDERS{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre><h3>Getting Started</h3><p>DateRangePicker is a custom element to select a date range on a calendar. It supports filtering of dates so that you can disable dates programmatically. Also supports min and max dates</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;form class=&quot;form-inline&quot;&gt;\n        &lt;date-range-picker\n            minDate=&quot;11/1/2015&quot;\n            maxDate=&quot;11/12/2016&quot; \n            [dateFilter]=&quot;dateFilter&quot;\n            (valueChange)=&quot;datePickerValueChange($event)&quot;&gt;\n            &lt;div class=&quot;form-group&quot;&gt;\n                &lt;label for=&quot;arrival&quot;&gt;Arrival Date&lt;/label&gt;\n                &lt;div class=&quot;date-picker-input-group&quot;&gt;\n                    &lt;input name=&quot;arrival&quot; startDateField class=&quot;form-control&quot; value=&quot;5/5/2016&quot; placeholder=&quot;Arrival&quot; /&gt;\n                &lt;/div&gt;\n            &lt;/div&gt;\n        \n            &lt;div class=&quot;form-group&quot;&gt;\n                &lt;label for=&quot;departure&quot;&gt;Departure Date&lt;/label&gt;\n                &lt;div class=&quot;date-picker-input-group&quot;&gt;\n                    &lt;input name=&quot;departure&quot; endDateField class=&quot;form-control&quot; value=&quot;5/10/2016&quot; placeholder=&quot;Departure&quot; /&gt;\n                &lt;/div&gt;\n            &lt;/div&gt;\n        &lt;/date-range-picker&gt;\n    &lt;/form&gt;\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class DateRangePickerExample {{'{'}}\n        dateRangePickerValue: DateRange;\n    \n        datePickerValueChange(eventValue: any){{'{'}}\n            this.dateRangePickerValue = eventValue;\n        {{'}'}}\n    \n        dateFilter(d: Date): boolean {{'{'}}\n        \n            //every Tuesday\n            if([2].indexOf(d.getDay()) > -1)\n                return false;\n        \n            return true;\n        {{'}'}}\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>DateRangePicker Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"attributes\" [sort]=\"attributesSort\">Loading table...</table-sortable><h3>StartDate / EndDate Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"dateFieldAttributes\" [sort]=\"attributesSort\">Loading table...</table-sortable></div>\n  "
    }), 
    __metadata('design:paramtypes', [])
], DateRangePickerDemo);
