var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
import { Event, EventColumns, EventsDefaultSort, Attribute, AttributeColumns, AttributesDefaultSort } from '../../utilities/demoUtilities';
export let ModalDemo = class ModalDemo {
    constructor() {
        this.closeText = "Cancel";
        this.size = "";
        this.attributes = [
            new Attribute('closeOnUnfocus', 'boolean', 'true', 'Closes the opened modal when the user clicks off of it'),
            new Attribute('closeButton', 'boolean', 'true', "Option to display an 'X' close button in the corner of the modal"),
            new Attribute('modalTitle', 'string', 'null', 'Text to display in modal header'),
            new Attribute('size', 'string', 'null', "Change the size of the modal. Supports 'sm' and 'small' for small size and 'lg' and 'large' for large. Null or empty will keep the default size")
        ];
        this.attributesColumns = AttributeColumns;
        this.attributesSort = AttributesDefaultSort;
        this.events = [
            new Event('close', 'null', 'When the modal is closed'),
            new Event('open', 'null', 'When the modal is opened')
        ];
        this.eventsColumns = EventColumns;
        this.eventsSort = EventsDefaultSort;
    }
    onClose() {
        console.log("Modal has been closed!");
    }
    onOpen() {
        console.log("Modal has been opened!");
    }
};
ModalDemo = __decorate([
    Component({
        template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">Modal</h2><p class=\"card-text\">Modal is a custom component to display a popup</p></div></div></div><div class=\"form-group row\"><label for=\"size\" class=\"col-md-1 form-control-label\">Size</label><div class=\"col-md-2\"><select name=\"size\" [(ngModel)]=\"size\" class=\"custom-select\"><option value=\"\">Default</option><option value=\"sm\">Small</option><option value=\"lg\">Large</option></select></div></div><button class=\"btn btn-primary\" (click)=\"modal.showModal()\">Show Modal</button><modal #modal modalTitle=\"Modal Title\" [closeButton]=\"true\" [closeOnUnfocus]=\"true\" [size]=\"size\" (close)=\"onClose()\" (open)=\"onOpen()\"><div class=\"modal-body\"><ul><li>Testing 1</li><li>Testing 2</li><li>Testing 3</li></ul></div><div class=\"modal-footer\"><button type=\"button\" class=\"btn btn-primary\" (click)=\"modal.closeModal()\"><i class=\"fa fa-chevron-left\"></i> Go Back</button></div></modal><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}Modal{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre><h3>Getting Started</h3><p>Modal is a custom element to create a popup</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;button class=&quot;btn btn-primary&quot; (click)=&quot;modal.showModal()&quot;&gt;Toggle Modal&lt;/button&gt;\n    &lt;modal #modal\n        modalTitle=&quot;Modal Title&quot;\n        [closeButton]=&quot;true&quot;\n        [closeOnUnfocus]=&quot;true&quot;\n        size=&quot;lg&quot;\n        (close)=&quot;onClose()&quot;\n        (open)=&quot;onOpen()&quot;&gt;\n        &lt;div class=&quot;modal-body&quot;&gt;\n            &lt;ul&gt;\n                &lt;li&gt;Any&lt;/li&gt;\n                &lt;li&gt;Html&lt;/li&gt;\n                &lt;li&gt;Here&lt;/li&gt;\n            &lt;/ul&gt;\n        &lt;/div&gt;\n        &lt;div class=&quot;modal-footer&quot;&gt;\n            &lt;button type=&quot;button&quot; class=&quot;btn btn-primary&quot; (click)=&quot;modal.closeModal()&quot;&gt;\n                &lt;i class=&quot;fa fa-chevron-left&quot;&gt;&lt;/i&gt; Go Back\n            &lt;/button&gt;\n        &lt;/div&gt;\n    &lt;/modal&gt;\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class ModalExample {{'{'}}\n        onClose(){{'{'}}\n            console.log(\"Modal has been closed!\");\n        {{'}'}}\n        onOpen(){{'{'}}\n            console.log(\"Modal has been opened!\");\n        {{'}'}}\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"attributes\" [sort]=\"attributesSort\">Loading table...</table-sortable><h3>Events</h3><table-sortable [columns]=\"eventsColumns\" [data]=\"events\" [sort]=\"eventsSort\">Loading table...</table-sortable></div>\n  "
    }), 
    __metadata('design:paramtypes', [])
], ModalDemo);
export var MODAL_DEMO_PROVIDERS = [
    ModalDemo
];
