var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
import { Event, EventColumns, EventsDefaultSort, Attribute, AttributeColumns, AttributesDefaultSort } from '../../utilities/demoUtilities';
export let PaginationDemo = class PaginationDemo {
    constructor() {
        this.totalPages = 10;
        this.pagesAtOnce = 5;
        this.currentPage = 1;
        this.showSteps = true;
        this.showEnds = true;
        this.showSelect = true;
        this.attributes = [
            new Attribute('currentPage', 'number', '1', 'Currently active page'),
            new Attribute('pagesAtOnce', 'number', '5', 'The max number of pages to be displayed at once'),
            new Attribute('totalPages', 'number', '10', 'Total number of pages'),
            new Attribute('showSelect', 'boolean', 'true', 'Show jump to select to choose page number from select box'),
            new Attribute('showEnds', 'boolean', 'true', 'Show first/last buttons to jump to the first or last page'),
            new Attribute('showSteps', 'boolean', 'true', 'Show arrows on ends of page numbers to step through pages')
        ];
        this.attributesColumns = AttributeColumns;
        this.attributesSort = AttributesDefaultSort;
        this.events = [
            new Event('currentPageChange', '$event = newCurrentPage: number', 'New active page number')
        ];
        this.eventsColumns = EventColumns;
        this.eventsSort = EventsDefaultSort;
    }
    pageChange(page) {
        this.currentPage = page;
    }
};
PaginationDemo = __decorate([
    Component({
        template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">Pagination</h2><p class=\"card-text\">Pagination is a custom component to display a pagination number list</p></div></div></div><section class=\"row m-a\"><div class=\"col-md-8\"><form><div class=\"form-group row\"><label for=\"totalPages\" class=\"col-sm-2 form-control-label\">Total Pages</label><div class=\"col-sm-2\"><input class=\"form-control\" [(ngModel)]=\"totalPages\" min=\"1\" type=\"number\" name=\"totalPages\"></div></div><div class=\"form-group row\"><label for=\"pagesAtOnce\" class=\"col-sm-2 form-control-label\">Pages At Once</label><div class=\"col-sm-2\"><input class=\"form-control\" [(ngModel)]=\"pagesAtOnce\" min=\"1\" [max]=\"totalPages\" type=\"number\" name=\"pagesAtOnce\"></div></div><div class=\"form-group row\"><label for=\"currentPage\" class=\"col-sm-2 form-control-label\">Current Page</label><div class=\"col-sm-2\"><input class=\"form-control\" [(ngModel)]=\"currentPage\" min=\"1\" [max]=\"totalPages\" type=\"number\" name=\"currentPage\"></div></div><div class=\"row\"><div class=\"checkbox col-md-3\"><label for=\"showSteps\" class=\"form-control-label\"><input [(ngModel)]=\"showSteps\" name=\"showSteps\" type=\"checkbox\"> Show Next/Previous</label></div><div class=\"checkbox col-md-3\"><label for=\"showEnds\" class=\"form-control-label\"><input [(ngModel)]=\"showEnds\" name=\"showEnds\" type=\"checkbox\"> Show First/Last</label></div><div class=\"checkbox col-md-3\"><label for=\"showSelect\" class=\"form-control-label\"><input [(ngModel)]=\"showSelect\" name=\"showSelect\" type=\"checkbox\"> Show Jump To</label></div></div></form><pagination [(currentPage)]=\"currentPage\" [totalPages]=\"totalPages\" [pagesAtOnce]=\"pagesAtOnce\" [showSelect]=\"showSelect\" [showEnds]=\"showEnds\" [showSteps]=\"showSteps\" (currentPageChange)=\"pageChange($event)\"></pagination></div></section><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}Pagination{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre><h3>Getting Started</h3><p>Pagination is a custom element to show an interactive list of page numbers to use for paging</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;pagination\n        [(currentPage)]=&quot;currentPage&quot;\n        totalPages=&quot;10&quot;\n        pagesAtOnce=&quot;1&quot;\n        [showSelect]=&quot;true&quot;\n        [showEnds]=&quot;true&quot;\n        [showSteps]=&quot;false&quot;\n        (currentPageChange)=&quot;pageChange($event)&quot;&gt;\n    &lt;/pagination&gt;\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class PaginationExample {{'{'}}\n        currentPage: number = 1;\n    \n        pageChange(page: number): void {{'{'}}\n            console.log('New Page: ' + page);\n        {{'}'}}\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"attributes\" [sort]=\"attributesSort\">Loading table...</table-sortable><h3>Events</h3><table-sortable [columns]=\"eventsColumns\" [data]=\"events\" [sort]=\"eventsSort\">Loading table...</table-sortable></div>\n  "
    }), 
    __metadata('design:paramtypes', [])
], PaginationDemo);
export var PAGINATION_DEMO_PROVIDERS = [
    PaginationDemo
];
