var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { NgModule, Component, ViewEncapsulation, Input } from "@angular/core";
import { CommonModule, JsonPipe } from "@angular/common";
import { FormsModule } from "@angular/forms";
import { FuiOrderByPipeModule } from "../../pipes/OrderBy/OrderBy";
import { FuiFormatPipeModule } from "../../pipes/Format/Format";
import { TableSortableSorting } from "./TableSortableSorting";
export let TableSortable = class TableSortable {
    constructor() {
    }
    selectedClass(column) {
        if (!column.sortable)
            return 'fuel-ui-not-sortable';
        return column.variable == this.sort.column ? 'sort-' + (this.sort.descending ? 'desc' : 'asc') : '';
    }
    changeSorting(column) {
        if (!column.sortable)
            return;
        var sort = this.sort;
        if (sort.column == column.variable) {
            sort.descending = !sort.descending;
        }
        else {
            sort.column = column.variable;
            sort.descending = false;
        }
    }
    convertSorting() {
        return this.sort.descending ? '-' + this.sort.column : this.sort.column;
    }
};
__decorate([
    Input(), 
    __metadata('design:type', Array)
], TableSortable.prototype, "columns", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Array)
], TableSortable.prototype, "data", void 0);
__decorate([
    Input(), 
    __metadata('design:type', TableSortableSorting)
], TableSortable.prototype, "sort", void 0);
TableSortable = __decorate([
    Component({
        selector: 'table-sortable',
        template: "\n    <div class=\"table-responsive\"><table class=\"table table-bordered table-hover table-striped fuel-ui-table-sortable\"><thead><tr><th *ngFor=\"let column of columns\" [class]=\"selectedClass(column)\" (click)=\"changeSorting(column)\">{{column.display}}</th></tr></thead><tbody><tr *ngFor=\"let object of data | orderBy : convertSorting()\"><td *ngFor=\"let column of columns\" [innerHtml]=\"object[column.variable] | format : column.filter\"></td></tr></tbody></table></div>\n  ",
        styles: ["\n    .fuel-ui-table-sortable > thead > tr > th:not(.fuel-ui-not-sortable) {\n      cursor: pointer;\n      position: relative;\n      background-image: none;\n      white-space: nowrap; }\n      .fuel-ui-table-sortable > thead > tr > th:not(.fuel-ui-not-sortable):after, .fuel-ui-table-sortable > thead > tr > th:not(.fuel-ui-not-sortable) .sort-desc:after, .fuel-ui-table-sortable > thead > tr > th:not(.fuel-ui-not-sortable) .sort-asc:after {\n        font-family: FontAwesome;\n        padding-left: 5px; }\n      .fuel-ui-table-sortable > thead > tr > th:not(.fuel-ui-not-sortable):after {\n        content: \"\f0dc\";\n        color: #ddd; }\n      .fuel-ui-table-sortable > thead > tr > th:not(.fuel-ui-not-sortable).sort-asc:after {\n        content: \"\f0de\";\n        color: #767676; }\n      .fuel-ui-table-sortable > thead > tr > th:not(.fuel-ui-not-sortable).sort-desc:after {\n        content: \"\f0dd\";\n        color: #767676; }\n  "],
        encapsulation: ViewEncapsulation.None,
        pipes: [JsonPipe]
    }), 
    __metadata('design:paramtypes', [])
], TableSortable);
export { TableSortableColumn } from "./TableSortableColumn";
export { TableSortableSorting } from "./TableSortableSorting";
export let FuiTableSortableModule = class FuiTableSortableModule {
};
FuiTableSortableModule = __decorate([
    NgModule({
        imports: [CommonModule, FormsModule, FuiFormatPipeModule, FuiOrderByPipeModule],
        declarations: [TableSortable],
        exports: [TableSortable]
    }), 
    __metadata('design:paramtypes', [])
], FuiTableSortableModule);
