var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
export class Person {
    constructor(firstName, lastName, age) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.info = new PersonInfo(age);
    }
}
export class PersonInfo {
    constructor(age) {
        this.age = age;
    }
}
export let OrderByDemo = class OrderByDemo {
    constructor() {
        this.typescriptCodeExample = `export class Person {
    public firstName: string;
    public lastName: string;
    public info: PersonInfo;

    constructor(firstName: string, lastName: string, age: number) {
        this.firstName = firstName;
        this.lastName = lastName;
        this.info = new PersonInfo(age);
    }
}

export class PersonInfo {
    constructor(public age: number){}
}

export class OrderByExample {
    people: Person[] = [
        new Person('Linus', 'Torvalds', 46),
        new Person('Larry', 'Ellison', 71),
        new Person('Mark', 'Zuckerberg', 31),
        new Person('Sergey', 'Brin', 42),
        new Person('Vint', 'Cerf', 72),
        new Person('Richard', 'Stallman', 62),
        new Person('John', 'Papa', 42)
    ];
}`;
        this.newPerson = new Person('', '', 18);
        this.people = [
            new Person('Linus', 'Torvalds', 46),
            new Person('Larry', 'Ellison', 71),
            new Person('Mark', 'Zuckerberg', 31),
            new Person('Sergey', 'Brin', 42),
            new Person('Vint', 'Cerf', 72),
            new Person('Richard', 'Stallman', 62),
            new Person('John', 'Papa', 42)
        ];
        this.peopleOrderBy1Desc = "-";
        this.peopleOrderBy1Property = "info.age";
        this.peopleOrderBy2Desc = "";
        this.peopleOrderBy2Property = "firstName";
        this.peopleOrderByConfig = [
            (this.peopleOrderBy1Desc + this.peopleOrderBy1Property),
            (this.peopleOrderBy2Desc + this.peopleOrderBy2Property)
        ];
        this.newFruit = "";
        this.fruit = ["orange", "apple", "pear", "grape", "banana"];
        this.fruitOrderByConfig = "+";
    }
    addToArrays() {
        this.fruit.push("new fruit");
        this.people.push(new Person('New', 'Person', 47));
    }
    setFruitConfig(newConfig) {
        this.fruitOrderByConfig = newConfig;
    }
    addFruit() {
        if (this.newFruit.length <= 0)
            return;
        this.fruit.push(this.newFruit);
        this.newFruit = '';
    }
    setPeopleConfig(type, index, newConfig) {
        if (type == "desc") {
            if (index == 1) {
                this.peopleOrderBy1Desc = newConfig;
            }
            else {
                this.peopleOrderBy2Desc = newConfig;
            }
        }
        else {
            if (index == 1) {
                this.peopleOrderBy1Property = newConfig;
            }
            else {
                this.peopleOrderBy2Property = newConfig;
            }
        }
        this.peopleOrderByConfig = [
            (this.peopleOrderBy1Desc + this.peopleOrderBy1Property),
            (this.peopleOrderBy2Desc + this.peopleOrderBy2Property)
        ];
    }
    addPerson() {
        if (this.newPerson.firstName.length <= 0 ||
            this.newPerson.lastName.length <= 0 ||
            this.newPerson.info.age <= 0)
            return;
        this.people.push(this.newPerson);
        this.newPerson = new Person('', '', 18);
    }
};
OrderByDemo = __decorate([
    Component({
        template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">OrderBy</h2><p class=\"card-text\">OrderBy is a custom pipe to order arrays of any arbitrary type.</p><p class=\"card-text\"><a href=\"http://www.fueltravel.com/blog/migrating-from-angular-1-to-2-part-1-pipes/\" target=\"_blank\">For a write up on the making of this pipe, feel free to check this out!</a></p></div></div></div><section class=\"row m-a\"><h3>One-Dimensional Arrays</h3><div class=\"col-md-4\"><h4>Add Fruit</h4><div class=\"form-group input-group\"><input class=\"form-control\" [(ngModel)]=\"newFruit\" name=\"newFruit\"><div class=\"input-group-btn\"><button type=\"button\" class=\"btn btn-primary\" (click)=\"addFruit()\" [disabled]=\"!newFruit\">Add</button></div></div></div></section><section class=\"row m-a\"><div class=\"col-md-4\"><h4>Unordered</h4><code>*ngFor=\"let f of fruit\"</code><br><ul><li *ngFor=\"let f of fruit\">{{f}}</li></ul></div><div class=\"col-md-8\"><h4>Ordered</h4><code>*ngFor=\"let f of fruit | orderBy : '{{fruitOrderByConfig}}'\"</code><br><code>*ngFor=\"let f of fruit | orderBy : ['{{fruitOrderByConfig}}']\"</code><br><div class=\"row\"><div class=\"col-md-4\"><ul><li *ngFor=\"let f of fruit | orderBy : fruitOrderByConfig\">{{f}}</li></ul></div><div class=\"col-md-6\" style=\"padding-top: 25px\"><div class=\"row form-group\"><label for=\"fruitOrderByConfig\" class=\"col-sm-4\">Order By</label><div class=\"col-sm-8\"><select class=\"form-control\" (change)=\"setFruitConfig($event.target.value)\"><option value=\"+\" [selected]=\"fruitOrderByConfig == '+'\">Ascending</option><option value=\"-\" [selected]=\"fruitOrderByConfig == '-'\">Descending</option></select></div></div></div></div></div></section><section class=\"row m-a\"><h3>Multi-Dimensional Arrays</h3><div class=\"col-md-8\"><h4>Add Person</h4><div class=\"row\"><div class=\"col-md-3 form-group\"><label for=\"firstName\">First Name</label><input class=\"form-control\" [(ngModel)]=\"newPerson.firstName\" name=\"firstName\"></div><div class=\"col-md-3 form-group\"><label for=\"lastName\">Last Name</label><input class=\"form-control\" [(ngModel)]=\"newPerson.lastName\" name=\"lastName\"></div><div class=\"col-md-3 form-group\"><label for=\"age\">Age</label><input type=\"number\" min=\"18\" max=\"120\" class=\"form-control\" [(ngModel)]=\"newPerson.info.age\" name=\"age\"></div><div class=\"col-md-3 form-group\"><label for=\"add\">&nbsp;</label><button type=\"button\" class=\"btn btn-primary form-control\" (click)=\"addPerson()\" [class.disabled]=\"!newPerson.firstName || !newPerson.lastName || !newPerson.info.age\">Add</button></div></div></div></section><section class=\"row m-a\"><div class=\"col-md-4\"><h4>Unordered</h4><code>*ngFor=\"let person of people\"</code><br><ul><li *ngFor=\"let person of people\">{{person.firstName}} {{person.lastName}}, {{person.info.age}}</li></ul></div><div class=\"col-md-8\"><h4>Ordered</h4><code>*ngFor=\"let person of people | orderBy : ['{{peopleOrderByConfig[0]}}', '{{peopleOrderByConfig[1]}}']\"</code><br><div class=\"row\"><div class=\"col-md-4\"><ul><li *ngFor=\"let person of people | orderBy : peopleOrderByConfig\">{{person.firstName}} {{person.lastName}}, {{person.info.age}}</li></ul></div><div class=\"col-md-6\" style=\"padding-top: 25px\"><div class=\"row form-group\"><label for=\"fruitOrderByConfig\" class=\"col-sm-4\">Order By</label><div class=\"col-sm-8\"><select class=\"form-control\" (change)=\"setPeopleConfig('property', 1, $event.target.value)\"><option value=\"firstName\" [selected]=\"peopleOrderBy1Property == 'firstName'\">First Name</option><option value=\"lastName\" [selected]=\"peopleOrderBy1Property == 'lastName'\">Last Name</option><option value=\"info.age\" [selected]=\"peopleOrderBy1Property == 'info.age'\">Age</option></select><select class=\"form-control\" (change)=\"setPeopleConfig('desc', 1, $event.target.value)\"><option value=\"\" [selected]=\"peopleOrderBy1Desc == ''\">Ascending</option><option value=\"-\" [selected]=\"peopleOrderBy1Desc == '-'\">Descending</option></select></div></div><div class=\"row form-group\"><label for=\"fruitOrderByConfig\" class=\"col-sm-4\">Then By</label><div class=\"col-sm-8\"><select class=\"form-control\" (change)=\"setPeopleConfig('property', 2, $event.target.value)\"><option value=\"firstName\" [selected]=\"peopleOrderBy2Property == 'firstName'\">First Name</option><option value=\"lastName\" [selected]=\"peopleOrderBy2Property == 'lastName'\">Last Name</option><option value=\"info.age\" [selected]=\"peopleOrderBy2Property == 'info.age'\">Age</option></select><select class=\"form-control\" (change)=\"setPeopleConfig('desc', 2, $event.target.value)\"><option value=\"\" [selected]=\"peopleOrderBy2Desc == ''\">Ascending</option><option value=\"-\" [selected]=\"peopleOrderBy2Desc == '-'\">Descending</option></select></div></div></div></div></div></section><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    {{'import {OrderByPipe} from \"fuel-ui/fuel-ui\"'}}\n    </code>\n    </pre><h3>Getting Started</h3><p>OrderBy is pipe that allows for sorting ascending or descending on any array types across multiple columns. Simply pass an array of strings with the name of the key within the object. Put a '-' in front of the name if you wish to sort descending on it. OrderBy pipe also allows for data to be pushed dynamically and sorted.</p><h3>Usage</h3><h4>One Dimensional Arrays</h4><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    *ngFor=\"let f of fruit | orderBy : '+'\"\n    *ngFor=\"let f of fruit | orderBy : ['+']\"\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class OrderByExample {{'{'}}\n        fruit: string[] = [\"orange\", \"apple\", \"pear\", \"grape\", \"banana\"];\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h4>Multi-Dimensional Arrays</h4><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    *ngFor=\"let person of people | orderBy : ['-info.age', 'firstName']\"\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight [innerHTML]=\"typescriptCodeExample\">\n    </code>\n    </pre></tab></tabset></div>\n  "
    }), 
    __metadata('design:paramtypes', [])
], OrderByDemo);
