"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var core_2 = require('@angular/core');
var core_3 = require("@angular/core");
var utilities_1 = require("../../utilities/utilities");
var DatePicker_1 = require("./DatePicker");
var DatePickerField_1 = require("./DatePickerField");
var InfiniteScroller_1 = require("../InfiniteScroller/InfiniteScroller");
var StartDateField = (function (_super) {
    __extends(StartDateField, _super);
    function StartDateField(element) {
        _super.call(this);
        this.element = element;
        this._value = "";
        this.valueChange = new core_2.EventEmitter();
        this.ngModelChange = new core_2.EventEmitter();
        this.dateChange = new core_2.EventEmitter();
        this.select = new core_2.EventEmitter();
    }
    Object.defineProperty(StartDateField.prototype, "value", {
        get: function () { return this._value; },
        set: function (value) {
            if (value == this._value)
                return;
            this._value = value;
            this._date = utilities_1.DateUtils.handleDateInput(value);
            this.valueChange.next(value);
            this.ngModelChange.next(value);
            this.dateChange.next(this._date);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StartDateField.prototype, "ngModel", {
        set: function (value) {
            this.value = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StartDateField.prototype, "date", {
        get: function () { return this._date; },
        set: function (date) {
            if (date.getTime() == this._date.getTime())
                return;
            this._date = date;
            this._value = date.toLocaleDateString();
            this.dateChange.next(date);
            this.ngModelChange.next(this._value);
            this.valueChange.next(this._value);
        },
        enumerable: true,
        configurable: true
    });
    StartDateField.prototype.inputChange = function (value) {
        this.value = value;
    };
    StartDateField.prototype.focused = function (event) {
        this.select.next(event);
    };
    StartDateField.prototype.selected = function (event) {
        this.select.next(event);
    };
    __decorate([
        core_3.HostBinding("value"), 
        __metadata('design:type', Object)
    ], StartDateField.prototype, "_value", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', String), 
        __metadata('design:paramtypes', [String])
    ], StartDateField.prototype, "value", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], StartDateField.prototype, "valueChange", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], StartDateField.prototype, "ngModel", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], StartDateField.prototype, "ngModelChange", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Date), 
        __metadata('design:paramtypes', [Date])
    ], StartDateField.prototype, "date", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], StartDateField.prototype, "dateChange", void 0);
    __decorate([
        core_3.HostListener("input", ["$event.target.value"]), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], StartDateField.prototype, "inputChange", null);
    __decorate([
        core_3.HostListener("focus", ["$event"]), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Event]), 
        __metadata('design:returntype', void 0)
    ], StartDateField.prototype, "focused", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], StartDateField.prototype, "select", void 0);
    __decorate([
        core_3.HostListener("click", ["$event"]), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [MouseEvent]), 
        __metadata('design:returntype', void 0)
    ], StartDateField.prototype, "selected", null);
    StartDateField = __decorate([
        core_1.Directive({
            selector: "[startDateField],.start-date-field",
        }), 
        __metadata('design:paramtypes', [core_2.ElementRef])
    ], StartDateField);
    return StartDateField;
}(DatePickerField_1.DatePickerField));
exports.StartDateField = StartDateField;
var EndDateField = (function (_super) {
    __extends(EndDateField, _super);
    function EndDateField(element) {
        _super.call(this);
        this.element = element;
        this._value = "";
        this.valueChange = new core_2.EventEmitter();
        this.ngModelChange = new core_2.EventEmitter();
        this.dateChange = new core_2.EventEmitter();
        this.select = new core_2.EventEmitter();
    }
    Object.defineProperty(EndDateField.prototype, "value", {
        get: function () { return this._value; },
        set: function (value) {
            if (value == this._value)
                return;
            this._value = value;
            this._date = utilities_1.DateUtils.handleDateInput(value);
            this.valueChange.next(value);
            this.ngModelChange.next(value);
            this.dateChange.next(this._date);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EndDateField.prototype, "ngModel", {
        set: function (value) {
            this.value = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EndDateField.prototype, "date", {
        get: function () { return this._date; },
        set: function (date) {
            if (date.getTime() == this._date.getTime())
                return;
            this._date = date;
            this._value = date.toLocaleDateString();
            this.dateChange.next(date);
            this.ngModelChange.next(this._value);
            this.valueChange.next(this._value);
        },
        enumerable: true,
        configurable: true
    });
    EndDateField.prototype.inputChange = function (value) {
        this.value = value;
    };
    EndDateField.prototype.focused = function (event) {
        this.select.next(event);
    };
    EndDateField.prototype.selected = function (event) {
        this.select.next(event);
    };
    __decorate([
        core_3.HostBinding("value"), 
        __metadata('design:type', Object)
    ], EndDateField.prototype, "_value", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', String), 
        __metadata('design:paramtypes', [String])
    ], EndDateField.prototype, "value", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], EndDateField.prototype, "valueChange", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], EndDateField.prototype, "ngModel", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], EndDateField.prototype, "ngModelChange", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Date), 
        __metadata('design:paramtypes', [Date])
    ], EndDateField.prototype, "date", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], EndDateField.prototype, "dateChange", void 0);
    __decorate([
        core_3.HostListener("input", ["$event.target.value"]), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], EndDateField.prototype, "inputChange", null);
    __decorate([
        core_3.HostListener("focus", ["$event"]), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Event]), 
        __metadata('design:returntype', void 0)
    ], EndDateField.prototype, "focused", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], EndDateField.prototype, "select", void 0);
    __decorate([
        core_3.HostListener("click", ["$event"]), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [MouseEvent]), 
        __metadata('design:returntype', void 0)
    ], EndDateField.prototype, "selected", null);
    EndDateField = __decorate([
        core_1.Directive({
            selector: "[endDateField],.end-date-field",
        }), 
        __metadata('design:paramtypes', [core_2.ElementRef])
    ], EndDateField);
    return EndDateField;
}(DatePickerField_1.DatePickerField));
exports.EndDateField = EndDateField;
var DateRangePicker = (function (_super) {
    __extends(DateRangePicker, _super);
    function DateRangePicker(changeDetector, renderer) {
        _super.call(this, changeDetector, renderer);
        this.valueChange = new core_2.EventEmitter();
        this._dateTarget = false;
        this.calendarHeight = utilities_1.MobileDetection.isAny() || window.innerWidth <= 480 || window.outerWidth <= 480 ? "auto" : "300px";
        this.startDateChange = new core_2.EventEmitter();
        this.endDateChange = new core_2.EventEmitter();
    }
    Object.defineProperty(DateRangePicker.prototype, "value", {
        set: function (value) {
            this._selectedDate = this.handleRangeInput(value).start;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "minDate", {
        get: function () { return this._minDate; },
        set: function (value) {
            this._minDate = utilities_1.DateUtils.handleDateInput(value);
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DateRangePicker.prototype, "maxDate", {
        get: function () { return this._maxDate; },
        set: function (value) {
            this._maxDate = utilities_1.DateUtils.handleDateInput(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "selectedDate", {
        get: function () { return this._selectedDate; },
        set: function (value) {
            this.selectDate(value);
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(DateRangePicker.prototype, "inputStartDate", {
        get: function () {
            return this.startDateField != null ? this.startDateField.value : "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "inputEndDate", {
        get: function () {
            return this.endDateField != null ? this.endDateField.value : "";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "startDate", {
        get: function () { return this._startDate; },
        set: function (value) {
            this._startDate = utilities_1.DateUtils.handleDateInput(value);
            if (this.startDateField != null)
                this.startDateField.value = this._startDate.toLocaleDateString();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateRangePicker.prototype, "endDate", {
        get: function () { return this._endDate; },
        set: function (value) {
            this._endDate = utilities_1.DateUtils.handleDateInput(value);
            if (this.endDateField != null)
                this.endDateField.value = this._endDate.toLocaleDateString();
        },
        enumerable: true,
        configurable: true
    });
    DateRangePicker.prototype.ngAfterContentInit = function () {
        var _this = this;
        if (typeof this.startDateField === "undefined")
            throw "Fuel-UI Error: DateRangePicker missing startDate field";
        var startDateValue = utilities_1.DateUtils.handleDateInput(this.startDateField.value);
        if (this.startDateField.value.length > 0
            && utilities_1.DateUtils.isValidDate(startDateValue))
            this.selectDate(startDateValue, false);
        else {
            this.selectDate(this._startDate, false);
            this.startDateField._value = this._startDate.toLocaleDateString();
        }
        this.startDateField.select
            .subscribe(function (event) {
            _this.showCalendar(event);
            _this.focusStartDate();
        });
        /* removed due to binding issues in FF
        this.startDateField.dateChange
            .subscribe((date: Date) => {
                if(this.startDate !== date)
                    this.startDate = date;
            });*/
        if (typeof this.endDateField === "undefined")
            throw "Fuel-UI Error: DateRangePicker missing endDate field";
        var endDateValue = utilities_1.DateUtils.handleDateInput(this.endDateField.value);
        if (this.endDateField.value.length > 0
            && utilities_1.DateUtils.isValidDate(endDateValue))
            this.selectDate(endDateValue, true);
        else {
            this.selectDate(this._endDate, true);
            this.endDateField._value = this._endDate.toLocaleDateString();
        }
        this.endDateField.select
            .subscribe(function (event) {
            _this.showCalendar(event);
            _this.focusEndDate();
        });
        /* removed due to binding issues in FF
        this.endDateField.dateChange
            .subscribe((date: Date) => {
                if(this.endDate !== date)
                    this.endDate = date;
            });*/
        this.dateFieldIcons.map(function (i) {
            i.selectEvent.subscribe(function (event) {
                _this.showCalendar(event);
            });
        });
        this.generateMonths();
    };
    DateRangePicker.prototype.selectDate = function (value, target) {
        this._selectedDate = value;
        var dateTarget = (typeof target !== "undefined" && target != null) ? target : this._dateTarget;
        if (!dateTarget) {
            this.startDate = value;
            if (this.startDateChange != null)
                this.startDateChange.next(this._startDate);
            if (utilities_1.DateUtils.isValidDate(this.endDate) && this.startDate > this.endDate)
                this.endDate = new Date(this.startDate.getTime() + 24 * 60 * 60 * 1000);
        }
        else {
            this.endDate = value;
            this.hideCalendar();
            if (this.endDateChange != null)
                this.endDateChange.next(this._endDate);
            if (utilities_1.DateUtils.isValidDate(this.startDate) && this.endDate < this.startDate)
                this.startDate = new Date(this.endDate.getTime() - 24 * 60 * 60 * 1000);
        }
        this._dateTarget = !dateTarget;
        if (this.startDate != null && this.endDate != null) {
            var startDate = new Date(this.startDate.getFullYear(), this.startDate.getMonth(), this.startDate.getDate());
            var endDate = new Date(this.endDate.getFullYear(), this.endDate.getMonth(), this.endDate.getDate());
            this.valueChange.next(new utilities_1.DateRange(startDate, endDate));
        }
        this.changeDetector.markForCheck();
    };
    DateRangePicker.prototype.handleRangeInput = function (value) {
        if (!(value instanceof utilities_1.DateRange))
            throw "DateRangePicker error: input is not of type DateRange";
        var range = value;
        this.startDate = range.start;
        this.endDate = range.end;
        return range;
    };
    DateRangePicker.prototype.focusStartDate = function () {
        this._dateTarget = false;
    };
    DateRangePicker.prototype.focusEndDate = function () {
        this._dateTarget = true;
    };
    DateRangePicker.prototype.checkStartDateTarget = function () {
        return !this._dateTarget;
    };
    DateRangePicker.prototype.checkEndDateTarget = function () {
        return this._dateTarget;
    };
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], DateRangePicker.prototype, "valueChange", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DateRangePicker.prototype, "value", null);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DateRangePicker.prototype, "minDate", null);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DateRangePicker.prototype, "maxDate", null);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Function)
    ], DateRangePicker.prototype, "dateFilter", void 0);
    __decorate([
        core_2.ViewChild(InfiniteScroller_1.InfiniteScroller), 
        __metadata('design:type', InfiniteScroller_1.InfiniteScroller)
    ], DateRangePicker.prototype, "calendarScroller", void 0);
    __decorate([
        core_2.ContentChild(StartDateField), 
        __metadata('design:type', StartDateField)
    ], DateRangePicker.prototype, "startDateField", void 0);
    __decorate([
        core_2.ContentChild(EndDateField), 
        __metadata('design:type', EndDateField)
    ], DateRangePicker.prototype, "endDateField", void 0);
    __decorate([
        core_2.ContentChildren(DatePickerField_1.DatePickerFieldStyler), 
        __metadata('design:type', core_2.QueryList)
    ], DateRangePicker.prototype, "dateFieldIcons", void 0);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], DateRangePicker.prototype, "startDateChange", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DateRangePicker.prototype, "startDate", null);
    __decorate([
        core_3.Output(), 
        __metadata('design:type', Object)
    ], DateRangePicker.prototype, "endDateChange", void 0);
    __decorate([
        core_3.Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], DateRangePicker.prototype, "endDate", null);
    DateRangePicker = __decorate([
        core_1.Component({
            selector: "date-range-picker",
            //styles: ["\n      .date-picker-overlay {\n        background-color: transparent;\n        display: block;\n        position: fixed;\n        top: 0;\n        right: 0;\n        bottom: 0;\n        left: 0;\n        z-index: 900; }\n        @media (max-width: 480px), screen and (max-device-width: 480px) {\n          .date-picker-overlay {\n            background-color: #55595c;\n            opacity: .75; } }\n\n      .date-picker-content {\n        position: relative;\n        top: 0;\n        left: 0; }\n\n      .fuel-ui-datepicker-input-group input:read-only, .fuel-ui-datepicker-input-group .form-control[readonly] {\n        background-color: #fff !important; }\n\n      .fuel-ui-datepicker-input-group .input-group-addon {\n        background-color: #fff !important; }\n\n      .date-picker-component {\n        border: 1px solid #eceeef;\n        z-index: 1000;\n        background-color: #fff;\n        font-size: .75rem;\n        position: absolute;\n        width: 350px;\n        height: auto;\n        top: 0;\n        left: 0;\n        overflow: hidden;\n        border-radius: 0.3rem;\n        -webkit-transition: all 0.1s ease;\n        -moz-transition: all 0.1s ease;\n        transition: all 0.1s ease; }\n        @media (max-width: 480px), screen and (max-device-width: 480px) {\n          .date-picker-component {\n            width: 90%;\n            height: 90%;\n            position: fixed;\n            top: 5%;\n            left: 5%; } }\n        .date-picker-component .input-group {\n          z-index: 110; }\n        .date-picker-component .container {\n          height: 100%; }\n          @media (max-width: 480px), screen and (max-device-width: 480px) {\n            .date-picker-component .container .calendar-container {\n              height: 91%; } }\n          .date-picker-component .container header {\n            position: relative;\n            top: 0;\n            left: 0;\n            vertical-align: middle;\n            background-color: #fff; }\n            .date-picker-component .container header .days-of-week {\n              background-color: #0275d8;\n              color: #fff; }\n            .date-picker-component .container header table {\n              border-top: none !important; }\n              .date-picker-component .container header table th, .date-picker-component .container header table td {\n                text-align: center; }\n            .date-picker-component .container header button {\n              border: none;\n              border-radius: 0;\n              color: #0275d8;\n              background-color: #fff;\n              width: 15%; }\n              .date-picker-component .container header button:active {\n                background-color: #eceeef; }\n              .date-picker-component .container header button.button-disable {\n                color: #eceeef;\n                cursor: default; }\n            .date-picker-component .container header .date-range {\n              width: 70%; }\n              .date-picker-component .container header .date-range span {\n                background-color: #eceeef;\n                border-left: none;\n                border-right: none; }\n            .date-picker-component .container header .input-group-addon {\n              border: none;\n              background-color: #fff !important; }\n            .date-picker-component .container header input {\n              border: none;\n              display: inline-block;\n              margin: 1px auto 0 auto;\n              cursor: pointer;\n              background-color: #fff !important; }\n            .date-picker-component .container header input:read-only, .date-picker-component .container header .form-control[readonly] {\n              background-color: #fff !important; }\n            .date-picker-component .container header input.target {\n              color: #0275d8; }\n              .date-picker-component .container header input.target::-webkit-input-placeholder {\n                color: #0275d8; }\n              .date-picker-component .container header input.target::-moz-placeholder {\n                color: #0275d8; }\n              .date-picker-component .container header input.target:-moz-placeholder {\n                color: #0275d8; }\n              .date-picker-component .container header input.target:-ms-input-placeholder {\n                color: #0275d8; }\n    "],
            template: "\n      <div class=\"date-picker-overlay\" aria-hidden=\"true\" *ngIf=\"calendarDisplayed\" (click)=\"hideCalendar()\"></div><div class=\"date-picker-content\"><ng-content></ng-content><div class=\"date-picker-component\" *ngIf=\"calendarDisplayed\" [style.left]=\"calendarX\" [style.top]=\"calendarY\"><div class=\"container p-a-0\"><header><button type=\"button\" class=\"btn btn-secondary pull-left\" (click)=\"scrollPrevMonth()\" [class.button-disable]=\"disablePrev()\"><i class=\"fa fa-chevron-left\"></i></button><div class=\"date-range pull-left input-group\"><input class=\"form-control text-xs-center\" [class.target]=\"checkStartDateTarget()\" (click)=\"focusStartDate()\" id=\"startDate\" [(ngModel)]=\"inputStartDate\" readonly=\"readonly\" placeholder=\"{{startLabel}}\"> <span class=\"input-group-addon\">- </span><input class=\"form-control text-xs-center\" [class.target]=\"checkEndDateTarget()\" (click)=\"focusEndDate()\" id=\"endDate\" [(ngModel)]=\"inputEndDate\" readonly=\"readonly\" placeholder=\"{{endLabel}}\"></div><button type=\"button\" class=\"btn btn-secondary pull-right\" (click)=\"scrollNextMonth()\" [class.button-disable]=\"disableNext()\"><i class=\"fa fa-chevron-right\"></i></button><table class=\"table m-b-0 days-of-week\"><tbody><tr><th>S</th><th>M</th><th>T</th><th>W</th><th>T</th><th>F</th><th>S</th></tr></tbody></table></header><div class=\"calendar-container m-a-0\"><infinite-scroller (next)=\"addNextMonth()\" (prev)=\"addPrevMonth()\" distance=\"100\" height=\"{{calendarHeight}}\" hideScrollbar=\"true\"><date-picker-calendar scroll-item *ngFor=\"let month of calendarMonths; let i=index\" [id]=\"i\" [minDate]=\"minDate\" [maxDate]=\"maxDate\" [dateFilter]=\"dateFilter\" [currentMonth]=\"month\" [(selectedDate)]=\"selectedDate\" [(startDate)]=\"startDate\" [(endDate)]=\"endDate\" [dateTarget]=\"_dateTarget\" (selectedDate)=\"hideCalendar()\">{{i}}</date-picker-calendar></infinite-scroller></div></div></div></div>\n    ",
            changeDetection: core_1.ChangeDetectionStrategy.OnPush
        }), 
        __metadata('design:paramtypes', [core_1.ChangeDetectorRef, core_1.Renderer])
    ], DateRangePicker);
    return DateRangePicker;
}(DatePicker_1.DatePicker));
exports.DateRangePicker = DateRangePicker;

//# sourceMappingURL=DateRangePicker.js.map
