"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var RangeDemo = (function () {
    function RangeDemo() {
        this.numbers = [];
        this.startNumber = 0;
        this.endNumber = 5;
        this.stepNumber = 1;
        this.parameters = [
            new demoUtilities_1.Attribute('start', 'number', '0', 'The starting number of the array'),
            new demoUtilities_1.Attribute('end', 'number', '4', 'The largest possible number of the array'),
            new demoUtilities_1.Attribute('step', 'number', '1', 'The amount of step between each number within the array')
        ];
        this.parametersColumns = demoUtilities_1.AttributeColumns;
        this.parametersSort = demoUtilities_1.AttributesDefaultSort;
    }
    RangeDemo = __decorate([
        core_1.Component({
            template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">Range</h2><p class=\"card-text\">Range is a custom pipe to dynamically create an array of numbers based on a given range</p></div></div></div><p><code>*ngFor=\"let number of numbers | range : {{startNumber}} : {{endNumber}} : {{stepNumber}}\"</code><br></p><p>Output: {{number | range : startNumber : endNumber : stepNumber | json}}</p><div class=\"form-group row\"><label for=\"startNumber\" class=\"col-sm-2 form-control-label\">Starting Number</label><div class=\"col-sm-2\"><input name=\"startNumber\" [(ngModel)]=\"startNumber\" type=\"number\" [max]=\"endNumber\" class=\"form-control\"></div></div><div class=\"form-group row\"><label for=\"endNumber\" class=\"col-sm-2 form-control-label\">Ending Number</label><div class=\"col-sm-2\"><input name=\"endNumber\" [(ngModel)]=\"endNumber\" type=\"number\" [min]=\"startNumber\" class=\"form-control\"></div></div><div class=\"form-group row\"><label for=\"stepNumber\" class=\"col-sm-2 form-control-label\">Step Number</label><div class=\"col-sm-2\"><input name=\"stepNumber\" [(ngModel)]=\"stepNumber\" type=\"number\" min=\"1\" class=\"form-control\"></div></div><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    {{'import {RangePipe} from \"fuel-ui/fuel-ui\"'}}\n    </code>\n    </pre><h3>Getting Started</h3><p>Range is a pipe that simply takes in 3 arguments, a <code>start</code> number, <code>end</code> number, and <code>step</code> number.</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    *ngFor=\"let number of numbers | range : start : end : step\"\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class RangeExample {{'{'}}\n        numbers:number[] = [];\n        start:number = 0;\n        end:number = 5;\n        step:number = 1;\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>Parameters</h3><table-sortable [columns]=\"parametersColumns\" [data]=\"parameters\" [sort]=\"parametersSort\">Loading table...</table-sortable></div>\n  "
        }), 
        __metadata('design:paramtypes', [])
    ], RangeDemo);
    return RangeDemo;
}());
exports.RangeDemo = RangeDemo;

//# sourceMappingURL=Range.Demo.js.map
